unit main;

interface
                                                                                  
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, Mask, FileCtrl,convert,ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    ConvertBtn: TSpeedButton;
    INputLabel: TLabel;
    SaveDlg: TSaveDialog;
    BatchBtn: TSpeedButton;
    ProgressBar1: TProgressBar;
    ConvertLabel: TLabel;
    Label2: TLabel;
    check4Dto3D: TCheckBox;
    AboutBtn: TSpeedButton;
    EPIbigendian: TCheckBox;
    FOVx10Check: TCheckBox;
    procedure ConvertBtnClick(Sender: TObject);
    procedure BrukerConv (lDirStr,lPassedFilenameStr: string; l4dto3d,lFOVx10: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BatchBtnClick(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



procedure TForm1.BrukerConv (lDirStr,lPassedFilenameStr: string;l4dto3d,lFOVx10:boolean);
const
     kMaxDTIDir = 256;
var
   lFloatRA: array [1..kMaxDTIDir*3] of double;
   lModFileNameStr,lBaseFileNameStr,lCommandStr,lBaseDir,lRecoStr,lAcqStr,lImgStr,lMethodStr: string;
   lTransposeVol,lTransposition,lVal,lDummy1,lDummy2: smallint;
   lXFOV,lYFOV,{lZFOV,}lDummy1F,lDummy2F: Single;
   {lWidSz,}lTransposeVolOffset,lTransposeSliceSz,lTransposeWidSz,lSliceWidSz,lTransInc,lTrans,lnSlice,lnVol,lVol,lInc,lActualImgSz,lImgSz,lSliceSz {,lnSlicesXVols} : integer;
   lInTextFile: TextFile;
   lOutF,lInF: File of byte;
   lBigEndSwap: boolean;
   lBuffer,lTempBuff: ByteP;
   //lAHdr: AHdr;
   //lDicomData: DicomData;
label
     1666; //close files and clear memory on abort
function FindFile (var lxBaseDir,lxPath: string; lxFileName: string; lPrompt: boolean): boolean;
//start from basedir and search for a file named filename.
//if found, lxName is set to file location.
var lxSearchDir,lxNewDir : string;
    lxSearchRec: TSearchRec;
begin
     result := false;
     lxSearchDir := lxBaseDir;
     lxPath := '';
     while (length(lxSearchDir) > 2) and (lxPath = '') do begin
           if fileexists (lxSearchDir+lxFileName) then
              lxPath := lxSearchDir+ lxFileName
           else begin //search in next outer directory
                repeat
                      delete(lxSearchDir,length(lxSearchDir), 1);
                until (length(lxSearchDir) < 2) or (lxSearchDir[length(lxSearchDir)] = '\');
           end;
     end;
     //did not find file by going to outer directory: no look into interior directories...
     //if someone started at c:\ this could go on for a long time - so only check first directory.
     if lxPath = '' then begin
        lxSearchDir := lxBaseDir;
        repeat
           lxNewDir := '';
           if FindFirst(lxSearchDir+'*.*', $00000010 {direcories}, lxSearchRec) = 0 then begin
              repeat
                    //                    if (lxSearchRec.Name <> '.') and (lxSearchRec.Name <> '..') and (FSize(lxSearchDir +lxSearchRec.Name) = 0) then begin
                    if (lxSearchRec.Name <> '.') and (lxSearchRec.Name <> '..') and ((lxSearchRec.Attr and faDirectory) <> 0) then begin
                       lxNewDir := lxSearchDir +lxSearchRec.Name+'\';
                    end;
              until (FindNext(lxSearchRec) <> 0) or (lxNewDir <> '');
           end;
           //Showmessage(lxSearchDir+lxFileName);
           FindClose(lxSearchRec);
           lxSearchDir := lxNewDir; //go one directory deeper into search path
           if fileexists (lxSearchDir+lxFileName) then
              lxPath := lxSearchDir+ lxFileName
        until (lxNewDir = '') {exhausted directories} or (lxPath <> '') {found file};
     end;
     if (lxPath = '') then begin
        if lPrompt then
           showmessage('BrukerConv error: Unable to find the file named '''+lxFileName+''' in the path '+lxBaseDir)
     end else result := true;
end;
function ReadLine: String; //read a line from text file - selected upper case characters
var lCh: char;
begin
   lCh := '#';//not eoln
   result := '';
   while (not eof(lInTextFile))  and (lCh <> chr(10){UNIXeoln}) and (lCh <> (chr (13){PC EOLN})) do begin
       if lCh in ['.','=','_','/','+','-',' ', '0'..'9','a'..'z','A'..'Z'] then
          result := result + upcase(lCh);
       read(lInTextFile, lCh);
   end;
end;

function NumChar (lCh: char): boolean;
begin
     result := lCh in ['.','+','-','e','E', '0'..'9'];

end;

function readFloatRA (lnFloats: integer): boolean;
//lFloatRA: array [1..kMaxDTIDir*3] of double;
var
   lnSep: integer;
   lStr : string;
   lCh,lPrevCh: char;
begin
    result := false;
    lStr := '';
    lnSep := 0;
    lPrevCh := ' ';
   while (not eof(lInTextFile))  and (lnSep < lnFloats) do begin
       read(lInTextFile, lCh);
       if NumChar(lCh) then
          lStr := lStr + lCh
       else if (not NumChar(lCh)) and (NumChar(lPrevCh)) then begin
          inc(lnSep);
          lFloatRA[lnSep] := strtofloat(lStr);
          lStr := '';

       end;
       lPrevCh := lCh;
   end;
   if lnSep < lnFloats then
      exit; //eof
   result := true;
end;

function ExportFloatRA (lFilename: string; lCols,lRows: integer): boolean;
var
   lR,lC,lPos: integer;
   lTextFile: TextFile;
begin
     result := false;
     if (lRows < 1) or (lCols < 1) or ((lRows*lCols) > kMaxDTIdir) then
        exit;
     if Fileexists(lFilename) then begin
         showmessage('Error: file exists named '+lFilename);
         exit;
     end;
     filemode := 2;//read+write
     assignfile(lTextFile,lFileName);
     rewrite(lTextFile);
     //write(lTextFile,lDynStr);
     for lR := 1 to lRows do begin
         lPos := lR;
         for lC := 1 to lCols do begin
             write(lTextFile,floattostr(lFloatRA[lPos])+' ');
             lPos := lPos + lRows;
         end; //each Col
         writeln(lTextFile);
     end; //each row
     closefile(lTextFile);
     result := true;
end;

function FlipFloatRA (lCols,lRows,lFlipRow: integer): boolean;
var
   lC,lPos: integer;
begin
     result := false;
     if (lRows < 1) or (lCols < 1) or ((lRows*lCols) > kMaxDTIdir) or (lFlipRow > lRows) then
        exit;
     lPos := lFlipRow;
     for lC := 1 to lCols do begin
         lFloatRA[lPos] := -lFloatRA[lPos];
         lPos := lPos + lRows;
     end; //each Col
     result := true;
end;  

procedure SegmentStr(var lxStr: string);
var lxPos, lxEqualPos: integer;
begin
     if length(lxStr) < 1 then exit;
     lxEqualPos := 0;
     for lxPos := 1 to length(lxStr) do
         if lxStr[lxPos] = '=' then lxEqualPos := lxPos;
     if lxEqualPos > 0 then
        lxStr := Copy (lxStr,lxEqualPos+1,length(lxStr)-lxEqualPos);
end;
procedure ReadFloats (lxInStr: string;var lx1,lx2,lx3: single);
var lxStr: string;
    lxPos,lxLen,lxVals: integer;
begin
 lxLen := length(lxInStr);
 lxPos := 1;
 lx1 := 0;
 lx2 := 0;
 lx3 := 0;
 lxVals := 0;
 repeat
  lxStr := '';
  While (lxPos <= lxLen) and (lxVals < 3) and (lxInStr[lxPos] <> ' ') and (lxInStr[lxPos] <> '/') do begin
        if lxInStr[lxPos] in [{'+',}'-',{'e','E',scientific}'.','0'..'9'] then
           lxStr := lxStr+(lxinStr[lxPos]);
        inc(lxPos);
  end;
  if (lxPos <= lxLen) then inc(lxPos); //skip spaces
  if length(lxStr) > 0 then begin
    inc(lxVals);
    try
       if lxVals = 1 then lx1 := strtofloat(lxStr)
       else if lxVals = 2 then lx2 := strtofloat(lxStr)
       else if lxVals = 3 then lx3 := strtofloat(lxStr);
    except
          on EConvertError do begin
             showmessage('Unable to convert the string '+lxStr+' to a number');
             //result := 1;
             exit;
          end;
    end; {except}
  end; //length > 0
until (lxPos >= lxLen);
end;
procedure ReadInts (lxInStr: string;var lx1,lx2,lx3: smallint);
var lx1f,lx2f,lx3f: single;
begin
    ReadFloats(lxInStr,lx1f,lx2f,lx3f);
    lx1 := round(lx1f);
    lx2 := round(lx2f);
    lx3 := round(lx3f);
end;
function ComStr( lxInput, lxCommand: string):boolean;
var
   lxIn: string;
begin
     result := false;
     if length(lxINput) < length(lxCommand) then exit;
     lxIn := Copy(lxINput,1,length(lxCommand));
     if lxIn = lxCommand then
         result := true;
end;
begin
//first step: look for all required files
   lBaseDir := extractfilepath(lDirStr);
   if not FindFile(lBaseDir,lRecoStr,'reco',true) then exit;
   if not FindFile(lBaseDir,lImgStr,'2dseq',true) then exit;
   if not FindFile(lBaseDir,lAcqStr,'acqp',true) then exit;
   clearhdr (gBHdr);
   gBHdr.Dim[3] := 1;
   lTransposition := 0;
   lBigEndSwap := false;
   lTransposeVol := 1;
//next step: parse RECO
   assignfile(lInTextFile,lRecoStr);
   reset(lInTextFile);
   lCommandStr := ReadLine;
   if lCommandStr <> 'TITLE=PARAMETER LIST' then begin
      showmessage('BrukerConv error: ''recon'' file should start with ''TITLE=PARAMETER LIST''.');
      goto 1666;
   end;
   repeat
         lCommandStr := ReadLine;
         if ComStr(lCommandStr,'RECO_WORDTYPE') then begin
            SegmentStr(lCommandStr);
            if lCommandStr = '_16BIT_SGN_INT' then begin
               gBHdr.datatype := 4; {16bit int}
               gBHdr.bitpix  := 16;
            end
            else if lCommandStr = '_32BIT_SGN_INT' then begin
               gBHdr.datatype := 8; {32 bit long}
                 gBHdr.bitpix := 32;
            end else begin
               gBHdr.datatype := 2; {8bit int}
               gBHdr.bitpix := 8;
            end;
         end;
         if ComStr(lCommandStr,'RECO_BYTE_ORDER') then begin
            SegmentStr(lCommandStr);
            if lCommandStr = 'LITTLEENDIAN' then lBigEndSwap := false
            else lBigEndSwap := true;
            //EPI are bigendian
         end;
         if ComStr(lCommandStr,'RECO_SIZE') then begin
            SegmentStr(lCommandStr); //find how many dimensions can be read
            ReadInts(lCommandStr,lVal,lDummy1,lDummy2);
            lCommandStr := ReadLine;
            case lVal of
                 2: ReadInts(lCommandStr,gBHdr.Dim[1],gBHdr.Dim[2],lDummy1);
                 3: ReadInts(lCommandStr,gBHdr.Dim[1],gBHdr.Dim[2],gBHdr.Dim[3]);
                 else begin showmessage('BrukerConv Error: RECO_SIZE specifies a '+inttostr(lVal)
                  +' dimensional file. This software only converts 2-4D images.');
                      goto 1666;
                 end;
            end;
         end; //RECO_SIZE
         if ComStr(lCommandStr,'RECO_TRANSPOSITION') then begin
            lCommandStr := ReadLine;
            ReadInts(lCommandStr,lTransposition,lDummy1,lDummy2);
            if (lTransposition < 0) or (lTransposition > 1) then begin
               showmessage('BrukerConv Error: RECO_TRANSPOSITION specifies an unsupported format: '+inttostr(lTransposition));
                      goto 1666;
            end;
         end; //RECO_transposition
         if ComStr(lCommandStr,'RECO_FOV') then begin
            SegmentStr(lCommandStr); //find how many dimensions can be read
            ReadInts(lCommandStr,lVal,lDummy1,lDummy2);
            lCommandStr := ReadLine;
            if (lVal = 2) or (lVal = 3) then
               ReadFloats(lCommandStr,lxFOV,lyFOV,lDummy1F{lzFOV})
            else begin showmessage('BrukerConv Error: RECO_FOV specifies a '+inttostr(lVal)
                  +' dimensional file. This software only converts 2-4D images.');
                      goto 1666;
                 end;

            {case lVal of
                 2: ReadFloats(lCommandStr,lxFOV,lyFOV,lDummy1F);
                 3: ReadFloats(lCommandStr,lxFOV,lyFOV,lzFOV);
                 else begin showmessage('BrukerConv Error: RECO_FOV specifies a '+inttostr(lVal)
                  +' dimensional file. This software only converts 2-4D images.');
                      goto 1666;
                 end;
            end;}
            (*if lFOVx10 then begin
                lxFOV := lxFOV *10;
                lyFOV := lyFOV * 10;
                lzFOV := lzFOV * 10;
            end;*)

         end; //RECO_FOV
   until eof(lInTextFile);//EOF
   closefile(lInTextFile);

//next step: parse ACQP file
   assignfile(lInTextFile,lAcqStr);
   reset(lInTextFile);
   lCommandStr := ReadLine;
   if lCommandStr <> 'TITLE=PARAMETER LIST' then begin
      showmessage('BrukerConv error: ''acqp'' file should start with ''TITLE=PARAMETER LIST''.');
      goto 1666;
   end;
   repeat
         lCommandStr := ReadLine;
         if ComStr(lCommandStr,'ACQ_SLICE_SEPN_MODE') then begin
            SegmentStr(lCommandStr);
            if (gBHdr.Dim[3] > 1) and (lCommandStr <> 'EQUIDISTANT') and (lCommandStr <> 'CONTIGUOUS') then
               showmessage('Acqp file suggests the slices are not equidistant. Analyze images assume equidistant slices.');
            lCommandStr := ReadLine;
         end else if ComStr(lCommandStr,'ACQ_SLICE_SEPN') then begin
            lCommandStr := ReadLine;
            ReadFloats(lCommandStr,gBHdr.pixdim[4],lDummy1F,lDummy2F); //only read 1st value: assume equidistant slices
         end;
         if ComStr(lCommandStr,{'NSLICES'}'ACQ_NS_LIST_SIZE') then begin
            SegmentStr(lCommandStr); //find how many dimensions can be read
            ReadInts(lCommandStr,lTransposeVol,lDummy1,lDummy2);
            //showmessage('slices'+inttostr(gBHdr.Dim[3]));
         end; //ACQ 'ACQ_NS_LIST_SIZE'
         if ComStr(lCommandStr,{'NSLICES'}'NI') then begin
            SegmentStr(lCommandStr); //find how many dimensions can be read
            ReadInts(lCommandStr,gBHdr.Dim[3],lDummy1,lDummy2);
            //showmessage('slices'+inttostr(gBHdr.Dim[3]));
         end; //ACQ NSLICES
         if (EPIbigendian.checked) and ComStr(lCommandStr,'BLIP_EPI') then begin
             lBigEndSwap := true;
             showmessage('blip'+lAcqStr);
             //FIX Bruker BUG: EPI images are Big Endian despite what the Recon file says
         end;
         if ComStr(lCommandStr,'ACQ_NR_COMPLETED') then begin
            SegmentStr(lCommandStr); //find how many dimensions can be read
            ReadInts(lCommandStr,gBHdr.Dim[4],lDummy1,lDummy2);
            //showmessage('vols'+inttostr(gBHdr.Dim[4]));
         end; //ACQ NR COMPLETED = VOLUMES
   until  eof(lInTextFile); //EOF
//End of reading ACQP file
   //start of method section: read method file - OPTIONAL: used for DTI: Bval and Bvecs
   //Also - check if FOV is CM or MM
   if FindFile(lBaseDir,lMethodStr,'method',false) then begin
      closefile(lInTextFile);
      assignfile(lInTextFile,lMethodStr);
      reset(lInTextFile);
      lCommandStr := ReadLine;
      if lCommandStr = 'TITLE=PARAMETER LIST' then begin //correct Method file format
         //showmessage('zero');
         repeat
               lCommandStr := ReadLine;
               //showmessage(lCommandStr);
               if ComStr(lCommandStr,'PVM_FOVCM') then begin  //mm not CM
                  SegmentStr(lCommandStr);
                  ReadInts(lCommandStr,lVal,lDummy1,lDummy2); //lVal is DTI bvals ( 35)
                  lCommandStr := ReadLine;
                  if lVal = 2 then begin
                       ReadFloats(lCommandStr,lxFOV,lyFOV,lDummy1F);
                       lxFOV := lxFOV * 10;
                       lyFOV  := lyFOV * 10;
                  end;
                  //showmessage(floattostr(lxFOV)+'rs' +floattostr(lyFOV));
               end; //PVM_FOVCM

         until eof(lInTextFile);//EOF
      end; //correct Method file format
   end; //method file exists
   //end of Method section

//1666 will close last open text file -assures aborts are handled smoothly
//Next Step: Save Analyze format header
   gBHdr.originator[1] := 0;
   gBHdr.originator[2] := 0;
   gBHdr.originator[3] := 0;
   if (gBHdr.dim[1] = 0) or (gBHdr.dim[2] = 0) or (gBHdr.dim[3] = 0) then begin
      showmessage('BrukerConv Error: Some dimensions equal zero.');
      goto 1666;
   end;
   gBHdr.pixdim[2] := lxFOV / gBHdr.dim[1];
   gBHdr.pixdim[3] := lyFOV / gBHdr.dim[2];
   if (lTransposition = 1) and (lTransposeVol > 1) then begin
      lTransposeWidSz := gBHdr.Dim[1] * (gBHdr.bitpix div 8) ;
      lTransposeSliceSz := gBHdr.Dim[2] * lTransposeWidSz;
      gBHdr.Dim[4] := lTransposeVol;
      gBHdr.Dim[1] := gBHdr.Dim[1] div gBHdr.Dim[4];
      gBHdr.Dim[3] := gBHdr.Dim[3] {* gBHdr.Dim[4]};
   end else
       lTransposition := 0;
   lActualImgSz := FSize(lImgStr);
   lImgSz := (gBHdr.bitpix div 8) * gBHdr.Dim[1]*gBHdr.Dim[2]*gBHdr.Dim[3]*gBHdr.Dim[4];
   lSliceSz := (gBHdr.bitpix div 8) * gBHdr.Dim[1]*gBHdr.Dim[2];
   lSliceWidSz := gBHdr.Dim[1]*(gBHdr.bitpix div 8);
   if (lActualImgSz <> lImgSz) and ((lActualImgSz mod (lSliceSz*gBHdr.Dim[3]))=0) then begin
      gBHdr.Dim[4] :=lActualImgSz div (lSliceSz*gBHdr.Dim[3]);
      lImgSz := (gBHdr.bitpix div 8) * gBHdr.Dim[1]*gBHdr.Dim[2]*gBHdr.Dim[3]*gBHdr.Dim[4];
   end; //the acqp file does not always correctly specify the number of volumes
   if gBHdr.dim[4] = 0 then begin
      showmessage('BrukerConv Error: No slices to convert.');
      goto 1666;
   end;
   if gBHdr.dim[4] > 1 then
      gBHdr.dim[0] := 4 //4D data
   else
       gBHdr.dim[0] := 3;

   lnVol := gBHdr.Dim[4];
   lnSlice := gBHdr.Dim[3];
   //lie about image dimensions....
   if lFOVx10 then begin
      gBHdr.pixdim[2] := gBHdr.pixdim[2] * 10;
      gBHdr.pixdim[3] := gBHdr.pixdim[3] * 10;
      gBHdr.pixdim[4] := gBHdr.pixdim[4] * 10;
   end;

   //
   if lPassedFilenameStr = '' then begin
      repeat
         if not SaveDlg.Execute then goto 1666;
         lBaseFilenameStr := ExtractFilePath(SaveDlg.FileName)+ParseFileName(ExtractFileName(SaveDlg.FileName))+'.img';
         if fileexists(lBaseFileNameStr) then showmessage('An image file exists named '+lBaseFilenameStr);
      until (not fileexists(lBaseFileNameStr));
   end else begin
       lBaseFileNameStr := lPassedFilenameStr;
       if fileexists(lBaseFileNameStr) then begin
          showmessage('An image file exists named '+lBaseFilenameStr);
          goto 1666;
       end;
   end;
   //lnSlicesXVols := gBHdr.Dim[3]*gBHdr.Dim[4];
   if ((lIMgSz+ (sizeof(AHdr)* gBHdr.Dim[4]) )> DiskFreeEX(lBaseFilenameStr)) then begin
        ShowMessage('There is not enough free space on the destination disk to save the image: '+lBaseFilenameStr+
          'Volumes = '+inttostr(gBHdr.Dim[4])+ ' Mb per volume = '+ floattostr(lImgSz / (1024*1024)));
        goto 1666;
   end;
   if lImgSz > lActualImgSz then begin
        ShowMessage('The image file is smaller than expected.'+lImgStr);
        goto 1666;
   end;
(*Next step copies image data*)
   ConvertLabel.caption := 'Processing: '+lImgStr;
   Form1.refresh;
   ProgressBar1.max := gBHdr.Dim[3]*gBHdr.Dim[4];
   GetMem(lBuffer,lSliceSz);
   FileMode := 0;  { Set file access to read only }
   AssignFile(lInF, lImgStr);//OpenDlg.FileName);
   Reset(lInF);
   lModFilenameStr := lBaseFilenameStr;
   for lVol := 1 to lnVol do begin
      if (lVol=1) or (l4dto3d) then begin //create header and image
         if l4dto3d then begin
            gBHdr.Dim[0] := 3;
            gBHdr.Dim[4] := 1;
            lModFilenameStr := ExtractFilePath(lBaseFilenameStr)+ParseFileName(ExtractFileName(lBaseFilenameStr))+inttostr(lVol)+'.img';
         end;
         if not SaveBHdr (lModFilenameStr, lBigEndSwap) then begin
            showmessage('BrukerConv: Error saving header.');
            FreeMem(lBuffer,lSliceSz);
            CloseFile(lInF);
            goto 1666;
         end; //SaveHdr OK
         AssignFile(lOutF, lModFilenameStr);
         Rewrite(lOutF);
      end;
      for lInc := 1 to lnSlice do begin //the previous loop should check if these files exist and are the correct size
           ProgressBar1.position := lInc+ ((lVol-1)* lnSlice);
           Application.processmessages;
           FileMode := 0;  { Set file access to read only: allows reading of all files }
           if lTransposition = 1 then begin
              //lTransposeWidSz := gBHdr.Dim[1] * (gBHdr.bitpix div 8) ;
              //lTransposeSliceSz
              GetMem(lTempBuff,lTransposeSliceSz);
              Seek(lInF,(lInc-1)*lTransposeSliceSz); //start of transpose
              BlockRead(lInF, lTempBuff^, lTransposeSliceSz);
              lTransposeVolOffset := 1+((lVol-1) * lSliceWidSz);
              for lTransInc := 1 to (gBHdr.Dim[2]) do begin
                  Move(lTempBuff[lTransposeVolOffset],lBuffer[1+((lTransInc-1)*lSliceWidSz)],lSliceWidSz);
                  lTransposeVolOffset := lTransposeVolOffset+lTransposeWidSz;
              end;
              FreeMem(lTempBuff);
           end else
               BlockRead(lInF, lBuffer^, lSliceSz);
           FileMode := 2;  { Set file access to read/write }
           BlockWrite(lOutF, lBuffer^, lSliceSz);
      end; //lInc := 1 txxo lnSeries
      if (lVol = lnVol) or (l4Dto3D) then
          CloseFile(lOutF);
   end;
   CloseFile(lInF);
   Freemem(lBuffer);
   ProgressBar1.position := 0;
   //start of method section: read method file - OPTIONAL: used for DTI: Bval and Bvecs
   //Also - check if FOV is CM or MM
   if FindFile(lBaseDir,lMethodStr,'method',false) then begin
      closefile(lInTextFile);
      assignfile(lInTextFile,lMethodStr);
      reset(lInTextFile);
      lCommandStr := ReadLine;
      if lCommandStr = 'TITLE=PARAMETER LIST' then begin //correct Method file format
         //showmessage('zero');
         repeat
               lCommandStr := ReadLine;

               if ComStr(lCommandStr,'PVM_DWEFFBVAL') then begin
                  SegmentStr(lCommandStr);
                  ReadInts(lCommandStr,lVal,lDummy1,lDummy2); //lVal is DTI bvals ( 35)
                  if lVal > kMaxDTIdir then
                     //showmessage('Error: only able to extract '+inttostr(kMaxDTIdir)+' or fewer DTI directions')
                  else if (lVal > 1)  then begin  //lDummy1 = 3: each vector composed of 3 values
                     if readFloatRA(lVal) then begin
                        for lDummy1 := 1 to lVal do
                            lFloatRA[lDummy1] := round(lFloatRA[lDummy1]);
                        ExportFloatRA (changefileext(lModFilenameStr,'.bval'), lVal,1);
                     end; //read OK
                  end; //DTI matrix size is Nx3
               end; //PVM_DWGRADVEC
               if ComStr(lCommandStr,'PVM_DWGRADVEC') then begin
                  SegmentStr(lCommandStr);
                  ReadInts(lCommandStr,lVal,lDummy1,lDummy2); //lVal is DTI directions - e.g. ( 35, 3 )
                  if lVal > kMaxDTIdir then
                     showmessage('Error: only able to extract '+inttostr(kMaxDTIdir)+' or fewer DTI directions')
                  else if (lVal > 1) and (lDummy1 = 3)  then begin  //lDummy1 = 3: each vector composed of 3 values
                     if readFloatRA(lVal*lDummy1) then begin
                        FlipFloatRA(lVal,lDummy1,1); //flip sign of X direction
                        ExportFloatRA (changefileext(lModFilenameStr,'.bvec'), lVal,lDummy1);
                     end;
                  end; //DTI matrix size is Nx3
               end; //PVM_DWGRADVEC
         until eof(lInTextFile);//EOF
      end; //correct Method file format
   end; //method file exists
   //end of Method section
   (**) 1666:
   closefile(lInTextFile);
   ConvertLabel.caption := '';
end;

procedure TForm1.FormCreate(Sender: TObject);
var lIniFileName,lStr: string;
    lIniFile: TextFile;
begin
      SaveDlg.DefaultExt := 'hdr';
      SaveDlg.Filter := 'Analyze Header (*.hdr)|*.hdr';
    lIniFileName := (ExtractFilePath(ParamStr(0))+ParseFileName(ExtractFileName(ParamStr(0)))+'.ini');
    if Fileexists(lIniFileName) then begin
       assignfile(lIniFile,lIniFileName);
       reset(lIniFile);
       readln(lIniFile, lStr);
       InputLabel.caption := lStr;
       opendialog1.filename := lStr;
       opendialog1.initialdir :=  extractfilepath(lStr);
       readln(lIniFile, lStr);
       SaveDlg.FileName := (lStr);
       SaveDlg.InitialDir := extractfilepath(lStr);
       readln(lIniFile, lStr);
       if lStr = '3DTO4D' then check4Dto3D.checked := true;
       readln(lIniFile, lStr);
       if lStr = 'NOT FOVx10' then FOVx10Check.checked := false;
       readln(lIniFile, lStr);
       if lStr = 'EPIbigendian' then EPIbigendian.checked := true;
       closefile(lIniFile);

    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var lIniFileName: string;
    lIniFile: TextFile;
begin
    lIniFileName := (ExtractFilePath(ParamStr(0))+ParseFileName(ExtractFileName(ParamStr(0)))+'.ini');
    assignfile(lIniFile,lIniFileName);
    rewrite(lIniFile);
    writeln(lIniFile, INputLabel.caption);
    writeln(lIniFile, SaveDlg.FileName);
    if check4Dto3D.checked then
       writeln(lIniFile,'3DTO4D')
    else
        writeln(lIniFile,'NOT 3DTO4D');
    if FOVx10Check.checked then
       writeln(lIniFile,'FOVx10')
    else
        writeln(lIniFile,'NOT FOVx10');
    if EPIbigendian.checked then
       writeln(lIniFile,'EPIbigendian')
    else
        writeln(lIniFile,'NOT EPIbigendian');
    closefile(lIniFile);
end;

procedure TForm1.ConvertBtnClick(Sender: TObject);
begin
     showmessage('Please select the Bruker Format ''reco'', ''acqp'' or ''2dseq'' file.');
     if not opendialog1.execute then exit;
     InputLabel.caption := opendialog1.filename;
     //showmessage(Opendialog1.filename);
     BrukerConv (Opendialog1.filename,'',check4Dto3D.checked,FOVx10Check.checked);
end;

procedure TForm1.BatchBtnClick(Sender: TObject);
var
   lSearchRec: TSearchRec;
   lSearchDir,lFileName,lOutFilename: String;
begin
     showmessage('Please select a Bruker Format ''subject'' file.');
     if not opendialog1.execute then exit;
     INputLabel.caption := opendialog1.filename;
     if not SaveDlg.Execute then exit;
//     lOutFilename := ExtractFilePath(SaveDlg.FileName)+ParseFileName(ExtractFileName(SaveDlg.FileName))+'.img';
     lSearchDir := ExtractFilePath(Opendialog1.filename);
     lFileName := '';
     if FindFirst(lSearchDir+'*.*', faDirectory, lSearchRec) = 0 then begin
              repeat  //open each folder in succession
                    if (lSearchRec.Name <> '.') and (lSearchRec.Name <> '..') and (( lSearchRec.Attr and faDirectory) <> 0) then begin
                       lFileName := lSearchDir +lSearchRec.Name+'\acqp';
                       lOutFilename := ExtractFilePath(SaveDlg.FileName)+ParseFileName(ExtractFileName(SaveDlg.FileName))+lSearchRec.Name+'x'+'.img';
                       BrukerConv (lFileName,lOutFilename,check4Dto3D.checked,FOVx10Check.checked);
                       //BrukerConv (lFileName,lSearchDir+lSearchRec.Name+'x.img',check4Dto3D.checked);
                    end;
              until (FindNext(lSearchRec) <> 0);
     end;
     FindClose(lSearchRec); //free resources
end;

procedure TForm1.AboutBtnClick(Sender: TObject);
begin
showmessage('Bruker2Analyze converter 12/12/2007 by Chris Rorden. '+
  'Loosely based on the Perl script by Andrew Janke and Matthew Brett. '+
  'For more details, see www.mricro.com');
end;

procedure TForm1.FormShow(Sender: TObject);
begin
//BrukerConv ('C:\dti128x128\acqp','',check4Dto3D.checked);

end;

end.
